package com.bonus.material.settlement.mapper;

import java.util.List;

import com.bonus.common.biz.domain.lease.LeaseOutDetails;
import com.bonus.material.ma.domain.Type;
import com.bonus.material.settlement.domain.SltAgreementApply;
import com.bonus.material.settlement.domain.SltAgreementInfo;
import com.bonus.material.settlement.domain.SltAgreementRelation;
import com.bonus.material.task.domain.TmTask;
import org.apache.ibatis.annotations.Param;

/**
 * 结算信息Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface SltAgreementInfoMapper {
    /**
     * 查询结算信息
     * 
     * @param id 结算信息主键
     * @return 结算信息
     */
    public SltAgreementInfo selectSltAgreementInfoById(Long id);

    /**
     * 查询结算信息列表
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结算信息集合
     */
    public List<SltAgreementInfo> selectSltAgreementInfoList(SltAgreementInfo sltAgreementInfo);

    /**
     * 新增结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int insertSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 修改结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int updateSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 删除结算信息
     * 
     * @param id 结算信息主键
     * @return 结果
     */
    public int deleteSltAgreementInfoById(Long id);

    /**
     * 批量删除结算信息
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSltAgreementInfoByIds(Long[] ids);

    SltAgreementInfo getSltAgreementInfo(LeaseOutDetails record);

    List<SltAgreementInfo> getSltAgreementInfo4Project(SltAgreementInfo record);

    List<SltAgreementApply> getSltExam(SltAgreementInfo bean);

    String getCost(SltAgreementApply apply);

    List<SltAgreementRelation> getRelations(SltAgreementApply apply);

    int updSltInfo(SltAgreementInfo sltAgreementInfo);

    int insSltInfo(@Param("record") LeaseOutDetails record, @Param("agreementId")String agreementId, @Param("ma") Type ma);

    List<SltAgreementInfo> getLeaseList(SltAgreementInfo bean);

    List<SltAgreementInfo> getRepairDetailsList(@Param("taskList") List<TmTask> taskList);

    List<SltAgreementInfo> getScrapDetailsList(@Param("taskList") List<TmTask> taskList);

    List<SltAgreementInfo> getLoseList(SltAgreementInfo bean);

    int updateRelation(SltAgreementApply apply);

    int updateApply(SltAgreementApply apply);

    int updateMaStatus(SltAgreementInfo agreementInfo);
}
